/************************************
  REVISION LOG ENTRY
  Revision By: Mihai Filimon ( mfl@exontrol.com )
  Revised on 7/31/2009 04:53:00 PM

  This code may be used in compiled form in any way you desire. This
  file may not be redistributed modified or unmodified without the authors
  written consent.

 ************************************/

#include "stdafx.h"
#include "IsoApp.h"
#include "IsoAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BEGIN_INTERFACE_MAP( CIsoAppDlg, CDialog )
	INTERFACE_PART( CIsoAppDlg, __uuidof( EXPRINTLib::IPrintExt ), PrintExt )
END_INTERFACE_MAP()

BEGIN_MESSAGE_MAP(CIsoAppDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, &CIsoAppDlg::OnBnClickedButton1)
END_MESSAGE_MAP()

CIsoAppDlg::CIsoAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIsoAppDlg::IDD, pParent)
{
	CoInitialize( NULL );
}

CIsoAppDlg::~CIsoAppDlg()
{
	CoUninitialize();
}

STDMETHODIMP_(ULONG) CIsoAppDlg::XPrintExt::AddRef()
{
    METHOD_PROLOGUE(CIsoAppDlg, PrintExt);
    
    return pThis->ExternalAddRef();
}

STDMETHODIMP_(ULONG) CIsoAppDlg::XPrintExt::Release()
{
    METHOD_PROLOGUE(CIsoAppDlg, PrintExt)

    return pThis->ExternalRelease();
}

STDMETHODIMP CIsoAppDlg::XPrintExt::QueryInterface(REFIID iid, LPVOID far* ppvObj)     
{
    METHOD_PROLOGUE(CIsoAppDlg, PrintExt)

    return pThis->ExternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP CIsoAppDlg::XPrintExt::get_PageCount(VARIANT Options,long * pVal)
{
	METHOD_PROLOGUE(CIsoAppDlg, PrintExt)

	*pVal = 1;
	return S_OK;
}

STDMETHODIMP CIsoAppDlg::XPrintExt::raw_DrawPage( VARIANT Options, long hdc, EXPRINTLib::IPage* pPage, VARIANT_BOOL* pbContinue )
{
	METHOD_PROLOGUE(CIsoAppDlg, PrintExt)

	HDC hDC = (HDC)hdc;
	RECT rtPage = {0};
	GetClipBox( hDC, &rtPage );
	Ellipse( hDC, rtPage.left, rtPage.top, rtPage.right, rtPage.bottom );

	return S_OK;
}

void CIsoAppDlg::OnBnClickedButton1()
{

	EXPRINTLib::IExPrintPtr spPrint;
	HRESULT hResult = spPrint.CreateInstance( __uuidof( EXPRINTLib::Print ) );
	if ( SUCCEEDED( hResult ) )
	{
		spPrint->AddRef(); /*This is required to let it opened until user closes it*/
		spPrint->PrintExt = &m_xPrintExt;
		spPrint->Caption = _T("ExPrint Version: <b>");
		spPrint->Caption += spPrint->Version;
		spPrint->Caption += _T("</b>");
		spPrint->Preview();
	}
	else
	{
		CString strError;
		strError.Format( _T("Error: 0x%08X"), hResult );

		// Collects the error's description
		LPVOID lpMsgBuf = NULL;
		if ( NULL != FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL,
			hResult,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			) )
		{
			strError += _T(" - ");
			strError += (LPCTSTR)lpMsgBuf;
			LocalFree( lpMsgBuf );
		}

		CString strInfo;
		if ( hResult == 0x8007007E )
		{
			strInfo = theApp.m_pszHelpFilePath;
			strInfo.Replace( _T("IsoApp.HLP"), _T("") );
			strInfo = _T("Copy the exprint.dll in the following folder: \r\n\r\n") + strInfo;
			strInfo += _T("\r\n\r\n");
		}
		strInfo += strError;
		MessageBox( strInfo, _T("Failed to create the eXPrint/COM component."), MB_ICONEXCLAMATION );
	}
}
